<?php

namespace FiloBlu\Refilo\Console\Command;

use FiloBlu\Refilo\Model\Exporter\Hreflang;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class SomeCommand
 */
class GenerateHreflang extends Command
{
    const NAME = 'name';
    /**
     * @var Hreflang
     */
    private $hreflang;

    /**
     * ImportBlocks constructor.
     * @param Hreflang $hrefLangBlock
     * @param string|null $name
     */
    public function __construct(
        Hreflang $hrefLangBlock,
        string $name = null
    ) {
        $this->hreflang = $hrefLangBlock;
        parent::__construct($name);
    }

    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $options = [
            new InputOption(
                self::NAME,
                null,
                InputOption::VALUE_REQUIRED,
                'Name'
            )
        ];

        $this->setName('refilo:sync:hreflang');
        $this->setDescription('Generate Hreflang for URLs');
        $this->setDefinition($options);

        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     * @return void
     * @throws \MongoDB\Driver\Exception\Exception
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $this->hreflang->exportHrefLang();
        $output->writeln('<info>Success.</info>');
    }
}
